/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ws3dcontrol;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.MouseEvent;
import javafx.scene.text.Font;

/**
 *
 * @author jucah
 */
public class WS3DController implements Initializable {

    @FXML
    private TextArea textArea;
    @FXML
    private Button bStart;
    @FXML
    private Button bShutdown;
    @FXML
    private Button bForward;
    @FXML
    private Button bBackward;
    @FXML
    private Button bRight;
    @FXML
    private Button bLeft;
    private StringBuilder cmd;
    private WS3DProxy ws3dProxy;
    private Robot r0;
    @FXML
    private Button bGetInfo;
    @FXML
    private Font x1;

    @FXML
    private void handleBStartAction(ActionEvent event) {
        cmd = new StringBuilder("new " + r0.getXCoord() + " " + r0.getYCoord() + " " + r0.getPitch());
        cmd.append(System.lineSeparator()).append("camera ").append(r0.getID());
        cmd.append(System.lineSeparator()).append("refuel ").append(r0.getID());
        cmd.append(System.lineSeparator()).append("start ").append(r0.getID());
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBGetInfoAction(ActionEvent event) {
        cmd = new StringBuilder("version");
        cmd.append(System.lineSeparator()).append("refuel ").append(r0.getID());
        cmd.append(System.lineSeparator()).append("getcreatinfo ").append(r0.getID());
        cmd.append(System.lineSeparator()).append("getcreatcoords ").append(r0.getID());
        cmd.append(System.lineSeparator()).append("getfullstatus3d ").append(r0.getID());
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBQuitAction(ActionEvent event) {
        cmd = new StringBuilder("stop " + r0.getID());
        cmd.append(System.lineSeparator()).append("getcreatcoords ").append(r0.getID());
        cmd.append(System.lineSeparator()).append("quit");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
        ws3dProxy.disconnect();
    }

    @FXML
    private void handleBForwardReleasedAction(MouseEvent event) {
        cmd = new StringBuilder("setturn " + r0.getID() + " 0 0 0");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBForwardPressedAction(MouseEvent event) {
        cmd = new StringBuilder("setturn " + r0.getID() + " 1 0 0");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBBackwardReleasedAction(MouseEvent event) {
        cmd = new StringBuilder("setturn " + r0.getID() + " 0 0 0");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBBackwardPressedAction(MouseEvent event) {
        cmd = new StringBuilder("setturn " + r0.getID() + " -1 0 0");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBRightReleasedAction(MouseEvent event) {
        cmd = new StringBuilder("getcreatcoords " + r0.getID() + " 0 0 0");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBRightPressedAction(MouseEvent event) {
        cmd = new StringBuilder("setturn " + r0.getID() + " 0 0.2 5.4");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBLeftReleasedAction(MouseEvent event) {
        cmd = new StringBuilder("getcreatcoords " + r0.getID() + " 0 0 0");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }

    @FXML
    private void handleBLeftPressedAction(MouseEvent event) {
        cmd = new StringBuilder("setturn " + r0.getID() + " 0 -0.2 -5.4");
        ws3dProxy.setCmd(cmd.toString());
        ws3dProxy.restart();
    }
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        Image imageForward = new Image(getClass().getResourceAsStream("/resources/tango_up_arrow_blue.png"));
        bForward.setGraphic(new ImageView(imageForward));
        Image imageBackward = new Image(getClass().getResourceAsStream("/resources/tango_down_arrow_blue.png"));
        bBackward.setGraphic(new ImageView(imageBackward));
        Image imageRight = new Image(getClass().getResourceAsStream("/resources/tango_right_arrow_blue.png"));
        bRight.setGraphic(new ImageView(imageRight));
        Image imageLeft = new Image(getClass().getResourceAsStream("/resources/tango_left_arrow_blue.png"));
        bLeft.setGraphic(new ImageView(imageLeft));
        try {
            ws3dProxy = new WS3DProxy("localhost", 4011);
        } catch (IOException ex) {
            Logger.getLogger(WS3DController.class.getName()).log(Level.SEVERE, null, ex);
        }
        //Logger.getLogger(WS3DController.class.getName()).log(Level.INFO, "Connected to localhost:4011");
        r0 = new Robot();
        ws3dProxy.setRobot(r0);
        textArea.textProperty().bind(ws3dProxy.valueProperty());
    }
}
